#include <iostream>
#include <fstream>
#include <cstdlib> // for exit()
using namespace std;

#define done(r, m) { cout << r << '\n'; cerr << m << '\n'; exit(0); }
#define wrong(m) done(0.0, m)
#define partial(m) done(0.5, m)
#define correct(m) done(1.0, m)

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: " << argv[0] << " input hint output");
	}

	ifstream in(argv[1]);
	ifstream hint(argv[2]);
	ifstream out(argv[3]);

	int k, x, y;
	in >> k >> x >> y;

	int t_hint;
	hint >> t_hint;

	int t_out, n_out;
	if (!out) wrong("No output");
	out >> t_out;
	if (!out) wrong("No T");
	if (t_out != t_hint) wrong("Wrong T");
	out >> n_out;
	if (!out) partial("No N");
	if (n_out < 1 or n_out > k) partial("Invalid N");
	int t_act = -x, k_act = 0;
	for (int i = 0; i < n_out; ++i) {
		int m;
		out >> m;
		if (!out) partial("No bag count");
		if (m < 1 or m > 30) partial("Invalid bag count");
		t_act += ((1 << m) - 1) + (x + m * y) + x;
		k_act += m;
	}
	if (k_act != k) partial("Wrong total number of bags");
	if (t_act != t_out) partial("Wrong total time");
	correct("OK");
}
