#include <iostream>

const int MAX = 100001;

int parent[MAX];
int size[MAX];

int find(int x) {
	if(parent[x] == x) return x;
	return parent[x] = find(parent[x]);
}
void merge(int a, int b) {
	a = find(a), b = find(b);
	if(a == b) return;
	if(size[b] > size[a]) std::swap(a, b);
	parent[b] = a;
	size[a] += size[b];
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);
	
	for(int i=0;i<MAX;i++) size[i]=1, parent[i]=i;

	int N, M, K;
	std::cin >> N >> M >> K;
	for(int i = 0; i < M; i++) {
		int l; std::cin >> l;
		int last=-1;
		for(int j = 0; j < l; j++) {
			int x; std::cin >> x;
			if(last>0) merge(last, x);
			last = x;
		}
	}
	for(int i=0;i<K;i++) {
		int k; std::cin >> k;
		std::cout << size[find(k)] << '\n';
	}
}
