#include <iostream>
#include <fstream>
#include <string>
using namespace std;

#define done(r, m) (cout << r << '\n', cerr << m << '\n', exit(0))

bool ispal(const string & s) {
	for (unsigned i = 0, j = s.length() - 1; i < j; ++i, --j) {
		if (s[i] != s[j]) {
			return false;
		}
	}
	return true;
}

int diff(const string & s1, const string & s2) {
	int k = 0;
	for (unsigned i = 0; i < s1.length(); ++i) {
		k += s1[i] != s2[i];
	}
	return k;
}

int main(int argc, char const *argv[]) {
	if(argc != 4) {
		done(0, "Usage: " << argv[0] << " input hint output");
	}

	ifstream in(argv[1]);
	ifstream hint(argv[2]);
	ifstream out(argv[3]);

	int n_in, k_hint, k_out;
	string s_in, s_hint, s_out;

	in >> n_in >> s_in;
	hint >> k_hint >> s_hint;

	if (!out) done(0.0, "No output");
	out >> k_out;
	if (!out) done(0.0, "No K");
	if (k_out != k_hint) done(0.0, "Wrong K");
	out >> s_out;
	if (!out) done(0.3, "Correct K, no S");
	if (s_out.length() != n_in) done(0.3, "Correct K, S has wrong length");
	if (!ispal(s_out)) done(0.3, "Correct K, S is not a palindrome");
	if (diff(s_in, s_out) > k_hint) done(0.3, "Correct K, S has too many changes");
	if (s_out > s_hint) done(0.6, "Correct K, S is not lexicographically least");
	done(1.0, "OK");
}
