import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

def error(msg):
    print(msg, file=sys.stderr)
    sys.exit(1)

n = int(fi.readline().strip())
if not (2 <= n <= 10**5):
    error("Invalid N")
fo.write('{0}\n'.format(n))

rs = []
for _ in range(n):
    x, y, w, h = map(int, fi.readline().split())
    if not (1 <= x and 1 <= y and 1 <= w and 1 <= h and x + w <= 10**9 and y + h <= 10**9):
        error("Invalid rectangle")
    rs.append((x, y, w, h))
    fo.write('{0} {1} {2} {3}\n'.format(x, y, w, h))

fi.close()
fo.close()

# index compress on y
ys = set()
for _, y, _, h in rs:
    ys.add(y)
    ys.add(y + h - 1)

ys = sorted(ys)
ymap = {y: i for i, y in enumerate(ys)}

def left(i):
    return i * 2

def right(i):
    return i * 2 + 1
    

class Seg:
    class Node:
        def __init__(self):
            self.v = 0
            self.u = -1

        def update(self, v):
            self.v = max(self.v, v)
            self.u = max(self.u, v)
            
    def __init__(self, n):
        c = 1
        while c < n:
            c *= 2
        n = c
    
        self.n = n
        self.nodes = [Seg.Node() for _ in range(2 * n)]
    
    def apply(self, i):
        no = self.nodes[i]
        if no.u != -1:
            if i < self.n:
                self.nodes[left(i)].update(no.u)
                self.nodes[right(i)].update(no.u)
            no.u = -1
        
    def max(self, l, r, i = 1, lb = 0, rb = None):
        if rb is None:
            rb = self.n

        if rb <= l or r <= lb:
            return -1
            
        if l <= lb and rb <= r:
            return self.nodes[i].v

        self.apply(i)
        
        d = (rb - lb) // 2
        return max(self.max(l, r, left(i), lb, rb - d), self.max(l, r, right(i), lb + d, rb))

    def update(self, l, r, v, i = 1, lb = 0, rb = None):
        if rb is None:
            rb = self.n

        if rb <= l or r <= lb:
            return
            
        if l <= lb and rb <= r:
            self.nodes[i].update(v)
            return
        
        self.apply(i)
        self.nodes[i].v = max(self.nodes[i].v, v)
        d = (rb - lb) // 2
        self.update(l, r, v, left(i), lb, rb - d)
        self.update(l, r, v, right(i), lb + d, rb)
        
# check for overlaps
rs.sort()
seg = Seg(len(ymap) + 1)
for x, y, w, h in rs:
    il = ymap[y]
    ir = ymap[y + h - 1] + 1
    mr = seg.max(il, ir)
    if mr > x:
        error("Overlap")
    seg.update(il, ir, x + w)

mxy = max(y + h for x, y, w, h in rs)
if all(y == h == 1 for x, y, w, h in rs):
    print("Subtask 1")
elif len(rs) <= 1000:
    print("Subtask 2")
elif mxy <= 3:
    print("Subtask 3")
elif mxy <= 50:
    print("Subtask 4")
else:
    print("Subtask 5")
