import matplotlib.pyplot as plt

DESK = {"color": (0.4, 0.4, 0.8), "linewidth": 1}
DESK_EDGE = {"color": (0.2, 0.2, 0.5), "linewidth": 3}
ROOM = {"color": (0.1, 0.1, 0.1), "linewidth": 5}
WALL = {"color": (1.0, 0.76, 0.02), "linewidth": 2, "linestyle": "dashed", "dashes": [4, 4]}
TEXT = {"color": (1, 1, 1)}

mxx, mxy = 0, 0

rs = []

def rect(xywh):
    x, y, w, h = xywh
    return [x, x + w, x + w, x, x], [y, y, y + h, y + h, y]

n = int(input())
for _ in range(n):
    x, y, w, h = r = tuple(map(int, input().split()))
    rs.append(r)
    plt.fill(*rect(r), **DESK)
    mxx = max(mxx, x + w)
    mxy = max(mxy, y + h)


xlines = []
ylines = []
for i, r in enumerate(rs, 1):
    x, y, w, h = r
    plt.plot(*rect(r), **DESK_EDGE)
    plt.text(x + 0.2, y + 0.4, str(i), **TEXT)
    xlines.append((y, x, x + w))
    xlines.append((y + h, x, x + w))
    ylines.append((x, y, y + h))
    ylines.append((x + w, y, y + h))

xlines.sort()
ylines.sort()

def overlaps(lines):
    for ai, (ay, ax1, ax2) in enumerate(lines):
        for bi in range(ai + 1, len(lines)):
            by, bx1, bx2 = lines[bi]
            if ay != by or bx1 >= ax2:
                break
            yield (ay, bx1, min(bx2, ax2))

if n <= 2000:
    for y, x1, x2 in overlaps(xlines):
        plt.plot([x1, x2], [y, y], **WALL)
    
    for x, y1, y2 in overlaps(ylines):
        plt.plot([x, x], [y1, y2], **WALL)
    
plt.plot(*rect((0, 0, mxx + 1, mxy + 1)), **ROOM)

plt.xlim(0, mxx + 2)
plt.ylim(0, mxy + 2)
plt.axis("equal")
plt.gca().invert_yaxis()
if max(mxx, mxy) <= 200:
    plt.xticks(range(mxx + 2))
    plt.yticks(range(mxy + 2))
plt.grid()

plt.show()
