#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

using ll = long long;

struct Rect {
  ll x, y, w, h;
};

ll line(map<ll, ll> &lines, ll y, ll x1, ll x2) {
  ll &c = lines[y];
  ll l = 0;
  if(c > x1) {
    l = min(c, x2) - x1;
  }
  c = max(c, x2);
  return l;
}

int main() {
  ios::sync_with_stdio(false);

  int n;
  cin >> n;

  vector<Rect> rs(n);
  for(auto &r : rs) {
    cin >> r.x >> r.y >> r.w >> r.h;
  }

  ll l = 0;
  map<ll, ll> lines;
  
  // x
  sort(rs.begin(), rs.end(), [](const Rect &a, const Rect &b) {
    return a.x < b.x;
  });
  for(auto r : rs) {
    l += line(lines, r.y, r.x, r.x + r.w) + line(lines, r.y + r.h, r.x, r.x + r.w);
  }

  // y
  lines.clear();
  sort(rs.begin(), rs.end(), [](const Rect &a, const Rect &b) {
    return a.y < b.y;
  });
  for(auto r : rs) {
    l += line(lines, r.x, r.y, r.y + r.h) + line(lines, r.x + r.w, r.y, r.y + r.h);
  }

  cout << l << "\n";
  
}
