#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

using ll = long long;

struct Rect {
  ll x, y, w, h;
};

struct Line {
  ll y;
  ll x1, x2;
};

ll overlap(Line a, Line b) {
  if(a.y != b.y) {
    return 0;
  }

  return max(min(a.x2, b.x2) - max(a.x1, b.x1), 0ll);
}

int main() {
  ios::sync_with_stdio(false);

  int n;
  cin >> n;

  vector<Rect> rs(n);
  for(auto &r : rs) {
    cin >> r.x >> r.y >> r.w >> r.h;
  }

  ll l = 0;

  for(auto it1 = rs.begin(); it1 != rs.end(); ++ it1) {
    Line x11 = Line{it1->y, it1->x, it1->x + it1->w};
    Line x12 = Line{it1->y + it1->h, it1->x, it1->x + it1->w};
    Line y11 = Line{it1->x, it1->y, it1->y + it1->h};
    Line y12 = Line{it1->x + it1->w, it1->y, it1->y + it1->h};
    for(auto it2 = it1 + 1; it2 != rs.end(); ++ it2) {
      Line x21 = Line{it2->y, it2->x, it2->x + it2->w};
      Line x22 = Line{it2->y + it2->h, it2->x, it2->x + it2->w};
      Line y21 = Line{it2->x, it2->y, it2->y + it2->h};
      Line y22 = Line{it2->x + it2->w, it2->y, it2->y + it2->h};

      l += overlap(x11, x21) + overlap(x11, x22) + overlap(x12, x21) + overlap(x12, x22);
      l += overlap(y11, y21) + overlap(y11, y22) + overlap(y12, y21) + overlap(y12, y22);
    }
  }
  
  cout << l << "\n";
  
}
